AppTitle = "Particle Wars"

Const width = 1024
Const height = 768

Graphics width, height
SetBlend (ALPHABLEND)
SeedRnd MilliSecs()

Type ship
	Field x:Float , y:Float , typ
	Field width,height
	Field winkel, speed:Float
End Type
Global shiplist:TList = CreateList()

Type shot
	Field x:Float, y:Float
	Field winkel, speed:Float
End Type
Global shotlist:TList = CreateList()

Type particle
	Field x:Float, y:Float
	Field r, g, b
	Field winkel, speed:Float
	Field alpha:Float
End Type
Global particlelist:TList = CreateList()


'Spielervars
Global sp_x = width / 2 - 15, sp_y = height / 2 - 15
Global sp_winkel, sp_speed = 3
Global sp_leben = 3
Global sp_richtung = -1
Global sp_shottimer
Global sp_shottime = 50
Global sp_multiplikator = 1
Global sp_multi_points
Global sp_difficult
Global sp_fortschritt
Global sp_bomben = 3
Global sp_shotspeed = 5
Global sp_shots = 2
Global sp_points
Global sp_lifetimer
Global sp_partikelmulti = 4
Global sp_died


Global schiffetot = 0

'Zhler
Global shotcount, shipcount, particlecount

'Spawnzeugs
Global spawntimer = MilliSecs()
Global spawnzeit = 2000


'Frames
Global ZaehlStart , FramesJeSekunde , Frames

Local timer = CreateTimer(60)

Repeat
	WaitTimer(timer)
	Cls
	
	If MouseHit(1) Then shipspawn(1, 3, 4)
	If MouseHit(2) Then shipspawn(2, 2, 4)
	If MouseDown(3) Then
		For I = 0 To 100
			createparticle(MouseX(), MouseY(), Rand(360), Rnd(0.01, 3), Rand(200, 255), Rand(0, 255), 0)
		Next
	EndIf
	

	updateships()
	updateshots()
	updateparticles()
	If sp_died = 0 Then
	sp_control()
	If sp_leben > 0 Then
	 sp_draw()
	 If sp_died = 0 spawningships()
	EndIf
	sp_shot()
	If sp_leben = 0 Then sp_explode()
	EndIf
	

	If MilliSecs() - sp_lifetimer > 1000 And sp_died = 1 Then
		If sp_leben <= - 1 Then
	 	sp_leben = 3
		sp_points = 0
		EndIf
		sp_died = 0
		sp_x = width / 2 - 15
		sp_y = height / 2 - 15
		sp_richtung = -1
		sp_multiplikator = 1
		sp_multi_points = sp_points
		For I = 0 To 200 * sp_partikelmulti
			createparticle(sp_x + 15, sp_y + 15, Rand(360), Rnd(1.9, 2), 0, 0, Rand(100, 255))
		Next
	End If
	
	SetColor 255, 255, 255
	FPS()
	
	If sp_leben = - 1 Then
		SetScale(5,5)
		DrawText "GAME OVER" , width / 2-200 , height / 2-50
		SetScale(1,1)
	End If
	
	
	DrawText "Schiffe: " + shipcount + "   Schss: " + shotcount + "   Partikel: " + particlecount, 0, 0
	DrawText "Punkte: " + sp_points, 0, 20
	DrawText "Multiplikator: " + sp_multiplikator + "X", 0, 40
	DrawText "Leben: " + sp_leben + "   Bomben: " + sp_bomben, 0, 80
	
	
	Flip 0
Until KeyHit(KEY_ESCAPE)
End




Function createship(x, y, typ, winkel,scale)
	Local s:ship = New ship
	s.x = x
	s.y = y
	s.typ = typ
	s.winkel = winkel
	s.width = scale
	s.height= scale
	Select typ
		Case 1
			s.speed = 1
		Case 2
			s.speed = 1.75
		Case 3
			s.speed = 2
		Case 4
			s.speed = 1.5
	End Select

	ListAddLast(shiplist, s)
End Function

Function updateships()
	shipcount = 0
	For s:ship = EachIn shiplist
		shipcount = shipcount + 1
		Select s.typ
			Case 1
			SetColor 255, 255, 0
			rect(s.x, s.y, s.width, s.height)
			s.x = s.x + Cos(s.winkel) * s.speed
			s.y = s.y + Sin(s.winkel) * s.speed
			If s.x < 0 Or s.x > width - 20 Then s.winkel = 180 - s.winkel
			If s.y < 0 Or s.y > height - 20 Then s.winkel = s.winkel * -1
			Case 2
			SetColor 255, 0, 0
			DrawOval s.x, s.y, s.width, s.height
			s.winkel = ATan2(s.y + 10 - sp_y - 15, s.x + 10 - sp_x - 15) + 160
			s.x = s.x + Cos(s.winkel) * s.speed
			s.y = s.y + Sin(s.winkel) * s.speed
			Case 3
			SetColor 0,255,0
			DrawRect s.x , s.y , s.width , s.height
			s.winkel = ATan2(s.y + 10 - sp_y - 15, s.x + 10 - sp_x - 15) + 160
			s.x = s.x + Cos(s.winkel) * s.speed +Rand(-1,1)
			s.y = s.y + Sin(s.winkel) * s.speed +Rand(-1,1)
			Case 4
			SetColor 0,255,0
			DrawRect s.x , s.y , s.width , s.height
			If s.x < 0 Or s.x > width - 20 Then s.winkel = 180 - s.winkel
			If s.y < 0 Or s.y > height - 20 Then s.winkel = s.winkel * -1
			s.x = s.x + Cos(s.winkel) * s.speed
			s.y = s.y + Sin(s.winkel) * s.speed 
		End Select
		'Schusscollision
		For sh:shot = EachIn shotlist
			If rectsoverlap(s.x, s.y, s.width, s.height, sh.x, sh.y, 4, 4) Then
				 createexplosion(s.x + 10, s.y + 10)
				 ListRemove(shiplist, s)
				 ListRemove(shotlist, sh)
				 sp_points = sp_points + 25 * s.typ * sp_multiplikator
				 If s.typ = 3 Then createship(s.x+Rand(-30,30) , s.y +Rand(-30,30), 4 , s.winkel , Rand(7 , 12) ) 
				 If s.typ=3 Then createship(s.x+Rand(-30,30),s.y+Rand(-30,30),4,s.winkel+Rand(-90,90),Rand(7,12))
			End If
		Next
		
		'Spieler Collision
		If rectsoverlap(sp_x + 5, sp_y + 5, s.width, s.height, s.x + 2, s.y + 2, 16, 16)
			sp_leben = sp_leben - 1
			schiffetot = 1
			sp_died = 1
			sp_explode()
		End If
		
		If KeyDown(KEY_SPACE) And sp_bomben > 0 Then
			For I = 0 To 5 * sp_partikelmulti
				createparticle(s.x + s.width/2, s.y + s.height/2, Rand(360), Rnd(0.5, 3), Rand(200, 255), Rand(0, 255), 0)
			Next
			ListRemove(shiplist, s)
		EndIf
		
		If schiffetot = 1 Then
			For I = 0 To 5 * sp_partikelmulti
				createparticle(s.x + s.width/2, s.y + s.height/2, Rand(360), Rnd(0.5, 3), Rand(200, 255), Rand(0, 255), 0)
			Next
			ListRemove(shiplist, s)
		End If
		
		
	Next
	If shipcount = 0 Then schiffetot = 0
End Function


Function shipspawn(art, typ, anzahl)
	Select art
		Case 1
		For I = 0 To 3
			Select I
				Case 0
				For J = 1 To anzahl / 4
				createship(Rand(0, 50), Rand(0, 50), typ, Rand(360),Rand(15,30))
				Next
				Case 1
				For J = 1 To anzahl / 4
				createship(Rand(width - 80, width - 30), Rand(0, 50), typ, Rand(360),Rand(15,30))
				Next
				Case 2
				For J = 1 To anzahl / 4
				createship(Rand(width - 80, width - 30), Rand(height - 80, height - 30), typ, Rand(360),Rand(15,30))
				Next
				Case 3
				For J = 1 To anzahl / 4
				createship(Rand(0, 50), Rand(height - 80, height - 30), typ, Rand(360),Rand(15,30))
				Next
			End Select
		Next
		Case 2
		For I = 1 To anzahl
			Repeat
				x = Rand(20, width - 20)
				y = Rand(20, height - 20)
			Until x < (sp_x - 200) Or x > (sp_x + 200) Or y < (sp_y - 200) Or y > (sp_y + 200)
			createship(x, y, typ, Rand(360),Rand(15,30))
		Next
	End Select
End Function

Function spawningships()
	If Rand(0, 700 - Int(sp_points / 500)) = 99 Then
		Local spawntyp:Int = Rand(1, 3)
		Select Rand(1, 4)
			Case 1
			shipspawn(1, spawntyp, Rand(1, 2) * 4)
			Case 2
			shipspawn(2, spawntyp, Rand(2, 10))
			Case 3
			shipspawn(2, Rand(1, 3), Rand(2, 8))
			Case 4
			shipspawn(1, Rand(1, 3), Rand(1, 3) * 4)
		End Select
	ElseIf Rand(1, 100) = 1 Then
	shipspawn(2, Rand(1, 3), 1)
	EndIf
End Function

Function rect(x, y, width, height)
	DrawRect x, y, 1, height
	DrawRect x, y, width, 1
	DrawRect x, y + height, width + 1, 1
	DrawRect x + width, y, 1, height + 1
End Function

Function rectsoverlap(x1, y1, width1, height1, x2, y2, width2, height2)
	If x1 + width1 > x2 And y1 + height1 > y2 And x1 < x2 + width2 And y1 < y2 + height2 Then
		Return 1
	Else
		Return 0
	EndIf
End Function

Function sp_control()
	If KeyDown(KEY_W) Then
		sp_y = sp_y - sp_speed
	EndIf
	If KeyDown(KEY_S) Then
		sp_y = sp_y + sp_speed
	EndIf
	If KeyDown(KEY_A) Then
		sp_x = sp_x - sp_speed
	EndIf
	If KeyDown(KEY_D) Then
		sp_x = sp_x + sp_speed
	EndIf
	If sp_x < 0 Then sp_x = 0
	If sp_y < 0 Then sp_y = 0
	If sp_x > width - 30 Then sp_x = width - 30
	If sp_y > height - 30 Then sp_y = height - 30
	'Schuss
	If KeyDown(KEY_UP) Then sp_richtung = 6
	If KeyDown(KEY_DOWN) Then sp_richtung = 2
	If KeyDown(KEY_LEFT) Then sp_richtung = 4
	If KeyDown(KEY_RIGHT) Then sp_richtung = 0
	If KeyDown(KEY_UP) And KeyDown(KEY_LEFT) Then sp_richtung = 5
	If KeyDown(KEY_UP) And KeyDown(KEY_RIGHT) Then sp_richtung = 7
	If KeyDown(KEY_DOWN) And KeyDown(KEY_LEFT) Then sp_richtung = 3
	If KeyDown(KEY_DOWN) And KeyDown(KEY_RIGHT) Then sp_richtung = 1
	
	If sp_leben < 1 Then sp_richtung = -1
	
	'Bombe
	If KeyHit(KEY_SPACE) And sp_bomben > 0 Then sp_bomben = sp_bomben - 1
	
	'Multiplikator
	If sp_points - sp_multi_points > 10000 * sp_multiplikator
		sp_multi_points = sp_points
		If sp_multiplikator < 5 Then sp_multiplikator = sp_multiplikator + 1
	End If
End Function

Function sp_draw()
	SetColor 255, 255, 255
	rect(sp_x, sp_y, 30, 30)
	rect (sp_x + 5, sp_y + 5, 20, 20)
End Function

Function sp_explode()
	For I = 0 To 200 * sp_partikelmulti
		createparticle(sp_x + 15, sp_y + 15, Rand(360), Rnd(0.1, 3), Rand(200, 255), Rand(0, 255), 0)
	Next
	sp_lifetimer = MilliSecs()
	If sp_leben = 0 Then
	sp_leben = -1
	sp_lifetimer = MilliSecs() + 2000
	EndIf
	
End Function

Function createshot(x, y, winkel, speed:Float)
	Local sh:shot = New shot
	sh.x = x
	sh.y = y
	sh.winkel = winkel
	sh.speed = speed
	ListAddLast(shotlist, sh)
End Function

Function updateshots()
	shotcount = 0
	For sh:shot = EachIn shotlist
		shotcount = shotcount + 1
		SetColor 0, 0, 255
		DrawOval sh.x, sh.y, 4, 4
		sh.x = sh.x + Cos(sh.winkel) * sh.speed
		sh.y = sh.y + Sin(sh.winkel) * sh.speed
		If sh.x < 0 Then
			For I = 0 To 0.5 * sp_partikelmulti + 1
				createparticle(sh.x, sh.y, Rand(270, 450), Rnd(0.5, 1.8), 0, 0, Rand(360))
			Next
			ListRemove(shotlist, sh)
		EndIf
		If sh.y < 0 Then
			For I = 0 To 0.5 * sp_partikelmulti + 1
				createparticle(sh.x, sh.y, Rand(0, 180), Rnd(0.5, 1.8), 0, 0, Rand(360))
			Next
			ListRemove(shotlist, sh)
		EndIf
		If sh.x > width Then
			For I = 0 To 0.5 * sp_partikelmulti + 1
				createparticle(sh.x, sh.y, Rand(90, 270), Rnd(0.5, 1.8), 0, 0, Rand(360))
			Next
			ListRemove(shotlist, sh)
		EndIf
		If sh.y > height Then
			For I = 0 To 0.5 * sp_partikelmulti + 1
				createparticle(sh.x, sh.y, Rand(180, 360), Rnd(0.5, 1.8), 0, 0, Rand(360))
			Next
			ListRemove(shotlist, sh)
		EndIf
		If sp_died = 1 Then
			For I = 0 To 1 * sp_partikelmulti
				createparticle(sh.x, sh.y, Rand(360), Rnd(0.5, 1.8), 0, 0, Rand(360))
			Next
			ListRemove(shotlist, sh)
		EndIf
	Next
End Function

Function sp_shot()
	If sp_richtung > - 1 Then
		If MilliSecs() - sp_shottimer > sp_shottime Then
			sp_shottimer = MilliSecs()
			If sp_shots >= 2 And sp_shots < 4 Then
				createshot(sp_x + 15, sp_y + 15, sp_richtung * 45 - 3, sp_shotspeed)
				createshot(sp_x + 15, sp_y + 15, sp_richtung * 45 + 3, sp_shotspeed)
			EndIf
			If sp_shots >= 3 And sp_shots < 4 Then
				createshot(sp_x + 15, sp_y + 15, sp_richtung * 45, sp_shotspeed)
			EndIf
			If sp_shots = 4 Then
				createshot(sp_x + 15, sp_y + 15, sp_richtung * 45 - 4, sp_shotspeed)
				createshot(sp_x + 15, sp_y + 15, sp_richtung * 45 + 2, sp_shotspeed)
				createshot(sp_x + 15, sp_y + 15, sp_richtung * 45 - 2, sp_shotspeed)
				createshot(sp_x + 15, sp_y + 15, sp_richtung * 45 + 4, sp_shotspeed)
			End If
			
		EndIf
	EndIf
End Function

Function createparticle(x, y, winkel, speed:Float, r = 255, g = 255, b = 255)
	Local p:particle = New particle
	p.x = x
	p.y = y
	p.r = r
	p.g = g
	p.b = b
	p.winkel = winkel
	p.speed = speed
	p.alpha = 1
	ListAddLast(particlelist, p)
End Function

Function updateparticles()
	particlecount = 0
	For p:particle = EachIn particlelist
		particlecount = particlecount + 1
		p.x = p.x + Cos(p.winkel) * p.speed
		p.y = p.y + Sin(p.winkel) * p.speed
		p.alpha = p.alpha - 0.01
		SetColor p.r, p.g, p.b
		SetAlpha(p.alpha)
		DrawRect p.x, p.y, 2, 2
		If p.alpha < 0 Then ListRemove(particlelist, p)
	Next
	SetAlpha(1)
End Function

Function createexplosion(x, y)
	For I = 0 To 10 * sp_partikelmulti
		createparticle(x, y, Rand(360), Rnd(0.1, 3), Rand(200, 255), Rand(0, 255), 0)
	Next
End Function

Function FPS()
Frames = Frames + 1

 If ZaehlStart + 1001 < MilliSecs() Then
  FramesJeSekunde = Frames
  Frames = 0
  ZaehlStart = MilliSecs()
 EndIf 

 DrawText "FPS: " + FramesJeSekunde, 0, 60
End Function 