Graphics3D 1024,768,16,2
AppTitle "Shifty 3D"

Dim board(4,3)
Dim tile(12)
Dim gMoving(4,3)
Type ball
		Field thingy%
		Field x#,y#,z#
		Field angle#
		Field xspeed#, yspeed#, zspeed#
End type	

Global gBlank_x%, gBlank_y%, gPixels%=0, gWait%=FALSE, victory%=FALSE, gDifficulty%, time%, moves%, difficulty$

Gosub init

Repeat
		victory=detect_victory()
		If victory=TRUE
				ShowEntity cube
				For a.ball = Each ball
						ShowEntity a\thingy
						a\angle#=(a\angle#+1.0) Mod 360.0
						a\x# = a\x# + cos(a\angle#)/35.0
						a\y# = a\y# + sin(a\angle#)/35.0
						a\z# = a\z# + sin(a\angle#)/35.0
  		  		PositionEntity a\thingy,a\x#,a\y#,a\z#
   					TurnEntity a\thingy, a\xspeed#, a\yspeed#, a\zspeed#
				Next
				TurnEntity cube,.5,.5,.5	
				RenderWorld()
						Else
								If gWait=true Then gPixels = gPixels + 64
								If MouseHit(1) user_input()
								Gosub split_3D
								Gosub show_2D
								DrawImage mouse,mousex(),mousey()								
		EndIf				
		Flip
Until KeyHit(1)
FlushKeys()

If victory = True
		time=millisecs()-time
		ClearWorld()
		cam=createcamera()
		tex=createtexture(512,512)
		SetBuffer TextureBuffer(tex)
		Color 255,0,255
		Text 20,0,"CONGRATULATIONS !!! "
		Text 20,25,"Time needed  :  " + time/1000 + " secs"
		Text 20,45,"Moves needed :  " + moves
		Text 20,65,"Difficulty   :  " + difficulty$
		SetBuffer BackBuffer()
		cube=createcube()
		ScaleEntity cube,5,5,.1
		ScaleTexture tex,2,2
		EntityTexture cube,tex
		PositionEntity cube,0,0,10
		Repeat
				RenderWorld()
				Flip
		Until KeyHit(1)
EndIf
End		

Function user_input()
Local x_tile%,y_tile%
If gWait=FALSE
		x_tile=ceil(mousex()/256.0)-1
		y_tile=ceil(mousey()/256.0)-1
		If Abs(gBlank_x-x_tile) + Abs(gBlank_y-y_tile) = 1
				If x_tile > gBlank_x Then gMoving(x_tile,y_tile)=203
				If x_tile < gBlank_x Then gMoving(x_tile,y_tile)=205
				If y_tile > gBlank_y Then gMoving(x_tile,y_tile)=200
				If y_tile < gBlank_y Then gMoving(x_tile,y_tile)=208
				gWait = True
				moves=moves+1			
		endif
EndIf
End function

.split_3D
For a.ball = Each ball
		ShowEntity a\thingy
		a\angle#=(a\angle#+1.0) Mod 360.0
		a\x# = a\x# + cos(a\angle#)/35.0
		a\y# = a\y# + sin(a\angle#)/35.0
		a\z# = a\z# + sin(a\angle#)/35.0
  	 PositionEntity a\thingy,a\x#,a\y#,a\z#
   	TurnEntity a\thingy, a\xspeed#, a\yspeed#, a\zspeed#
next
ShowEntity cube
TurnEntity cube,.5,.5,.5
RenderWorld()
Rect 768,512,256,256,1
For y=0 To 2
		For x=0 To 3
				GrabImage tile(1+x+y*4),x*256,y*256
		Next
Next
For a.ball = Each ball
		HideEntity a\thingy
Next
HideEntity cube
renderworld()
Return

.show_2D
For y=0 To 2
		For x=0 To 3
				If gMoving(x,y)=0 
						DrawImage tile(board(x,y)),x*256,y*256
								Else
										Select gMoving(x,y)
												Case 203 : DrawImage tile(board(x,y)),x*256-gPixels,y*256
												Case 205 : DrawImage tile(board(x,y)),x*256+gPixels,y*256
												Case 208 : DrawImage tile(board(x,y)),x*256,y*256+gPixels
												Case 200 : DrawImage tile(board(x,y)),x*256,y*256-gPixels
										End select
										If gPixels = 256 Then gPixels=0 : gMoving(x,y)=0 : board(gBlank_x,gBlank_Y)=board(x,y) : gBlank_x = x : gBlank_y = y : board(x,y)=12 : gWait=FALSE
				EndIf
				DrawImage grid,0,0	
		Next
Next
Return


Function Scramble()
Local x%,y%,z%,i%
For y=0 To 2
		For x=0 To 3
				board(x,y)=1+x+y*4
		next
Next
gBlank_x = 3 : gBlank_y = 2

repeat
		z=rand(1,4)
				Select z
						Case 1:	If gBlank_x<3 Then board(gBlank_x,gBlank_y)=board(gBlank_x+1,gBlank_y) : board(gBlank_x+1,gBlank_y) = 12 : gBlank_x=gBlank_x+1 : i=i+1
						Case 2:	If gBlank_x>0 Then board(gBlank_x,gBlank_y)=board(gBlank_x-1,gBlank_y) : board(gBlank_x-1,gBlank_y) = 12 : gBlank_x=gBlank_x-1 : i=i+1
						Case 3:	If gBlank_y<2 Then board(gBlank_x,gBlank_y)=board(gBlank_x,gBlank_y+1) : board(gBlank_x,gBlank_y+1) = 12 : gBlank_y=gBlank_y+1 : i=i+1
						Case 4:	If gBlank_y>0 Then board(gBlank_x,gBlank_y)=board(gBlank_x,gBlank_y-1) : board(gBlank_x,gBlank_y-1) = 12 : gBlank_y=gBlank_y-1 : i=i+1
				End select
Until i = gDifficulty
End Function


.init
SeedRnd MilliSecs()
HidePointer
cam = CreateCamera()
PositionEntity cam,0,0,-10
light=createlight()

menuetex=createtexture(256,256)
SetBuffer TextureBuffer(menuetex)
Color 0,0,255
Text 15,10,"SHIFTY 3D"
Text 5,40,"F1 --- EASY"
Text 5,50,"F2 --- MEDIUM"
Text 5,60,"F3 --- HARD"

scrolltex=createtexture(512,128)
SetBuffer TextureBuffer(scrolltex)
Color 0,255,255
Text 0,0,"This game was made for BBC20 . . . . . (c)2008 by PSY"

menuecube=createcube()
EntityTexture menuecube,menuetex
ScaleEntity menuecube,4,4,.1
ScaleTexture menuetex,1.5,1.5

scrollcube=createcube()
EntityTexture scrollcube,scrolltex
ScaleEntity scrollcube,10,2,.01
PositionEntity scrollcube,0,-8,0

grid = CreateImage(1024,768)
SetBuffer ImageBuffer(grid)
Color 255,0,255
For x=0 To 3
		For y=0 To 2
				Rect x*256+3,y*256+3,250,250,1
		next
Next
MaskImage grid,255,0,255

mouse=createimage(32,32)
SetBuffer ImageBuffer(mouse)
Color 255,0,0
Oval 5,5,25,25
Color 0,0,0
Oval 10,10,15,15

tex = CreateTexture(256,256)
SetBuffer TextureBuffer(tex)
For x=0 To 7
		For y= 0 To 7
				If (x+y) Mod 2 = 0 Then Color 0,0,0 Else Color 255,255,255
				Rect x*32,y*32,32,32,1
		Next
Next

SetBuffer BackBuffer()

For y=0 To 2
		For x=0 To 3
				tile(1+x+y*4) = createimage(256,256)
		Next
Next

Repeat
		angle#=(angle#+1) Mod 360
		p#=(p#-.001) Mod 1
		PositionTexture menuetex,cos(angle#)*.1+.1,sin(angle#)*.1+.1
		PositionTexture scrolltex,p#,1
		If Keydown(59) Then gDifficulty = 11 : difficulty$="easy"
		If Keydown(60) Then gDifficulty = 33 : difficulty$="medium"
		If Keydown(61) Then gDifficulty = 99 : difficulty$="hard"
		RenderWorld()
		flip
Until gDifficulty > 0

FreeTexture menuetex
FreeTexture scrolltex
FreeEntity menuecube
FreeEntity scrollcube

For i=1 To 40
		a.ball = New ball
		a\thingy = CreateSphere(32)
		EntityColor a\thingy,rand(255),rand(255),rand(255)
		EntityTexture a\thingy,tex
		a\x#=Rnd(-2.0,2.0) : a\y# = Rnd(-2.0,2.0) : a\z# = Rnd(-2.0,2.0)
		a\xspeed#=rnd(-5.0,5.0) : a\yspeed#=rnd(-5.0,5.0) : a\zspeed#=rnd(-5.0,5.0)
		a\angle#=rand(360)
		EntityAlpha a\thingy,rnd(.6,1.0)	
		EntityShininess a\thingy,1
Next
cube=createcube()
EntityTexture cube,tex
ScaleEntity cube,10,10,10
FlipMesh cube

Scramble()
time = millisecs()
Return

Function detect_victory()
		For y=0 To 2
				For x=0 To 3
						If board(x,y) <> 1+x+y*4 Then Return False
				next
		next
Return TRUE
End Function

